<?php
/*
//////////////////////////////////////////////////////////
//  SUPER ORDERS                                        //
//                                                      //
//  By Frank Koehl (PM: BlindSide)                      //
//                                                      //
//  Powered by Zen-Cart (www.zen-cart.com)              //
//  Portions Copyright (c) 2005 The Zen-Cart Team       //
//                                                      //
//  Released under the GNU General Public License       //
//  available at www.zen-cart.com/license/2_0.txt       //
//  or see "license.txt" in the downloaded zip          //
//////////////////////////////////////////////////////////
//  super_edit.php is based on:                         //
//  Edit Orders v1.59                                   //
//  by Scott Drake (http://www.ecdiscounts.com)         //
//////////////////////////////////////////////////////////
*/

//////////////////////////////////////////////
// Initialize essential files and variables //
//////////////////////////////////////////////

require('includes/application_top.php');
global $db;

require(DIR_WS_CLASSES . 'currencies.php');
$currencies = new currencies();

require(DIR_WS_CLASSES . 'order.php');
$oID = zen_db_prepare_input($_GET['oID']);
$order = new order($oID);

$step = zen_db_prepare_input($_POST['step']);
$add_product_categories_id = zen_db_prepare_input($_POST['add_product_categories_id']);
$add_product_products_id = zen_db_prepare_input($_POST['add_product_products_id']);
$add_product_quantity = zen_db_prepare_input($_POST['add_product_quantity']);
$add_product_options = zen_db_prepare_input($_POST['add_product_options']);
// Optional Tax Rate/Percent
$AddShippingTax = "0.0"; // e.g. shipping tax of 17.5% is "17.5"

// Next available order number (displayed for split order purposes)
$nextID = $db->Execute("SELECT (orders_id + 1) AS nextID FROM " . TABLE_ORDERS . " ORDER BY orders_id DESC LIMIT 1");
$nextID = $nextID->fields['nextID'];

$orders_statuses = array();
$orders_status_array = array();

$orders_status_query = $db -> Execute("SELECT orders_status_id, orders_status_name FROM " . TABLE_ORDERS_STATUS . " WHERE language_id = '" . (int)$_SESSION['languages_id'] . "'");

while (!$orders_status_query->EOF) {
  $orders_statuses[] = array('id' => $orders_status_query->fields['orders_status_id'],
                             'text' => $orders_status_query->fields['orders_status_name']);
  $orders_status_array[$orders_status_query->fields['orders_status_id']] = $orders_status_query->fields['orders_status_name'];
  $orders_status_query->MoveNext();
}
// JTD:10/19/05 - added for proper sort order support
$sort_orders = array();
$sort_order_query = $db -> Execute("SELECT configuration_key, configuration_value FROM " . TABLE_CONFIGURATION . " WHERE `configuration_title` = 'Sort Order'");
  while (!$sort_order_query -> EOF) {

  if ($sort_order_query->fields['configuration_key'] == 'MODULE_ORDER_TOTAL_SUBTOTAL_SORT_ORDER')
    $class = 'ot_subtotal';
  elseif ($sort_order_query->fields['configuration_key'] == 'MODULE_ORDER_TOTAL_SHIPPING_SORT_ORDER')
    $class = 'ot_shipping';
  elseif ($sort_order_query->fields['configuration_key'] == 'MODULE_ORDER_TOTAL_COUPON_SORT_ORDER')
    $class = 'ot_coupon';
  elseif ($sort_order_query->fields['configuration_key'] == 'MODULE_ORDER_TOTAL_TAX_SORT_ORDER')
    $class = 'ot_tax';
  elseif ($sort_order_query->fields['configuration_key'] == 'MODULE_ORDER_TOTAL_LOWORDERFEE_SORT_ORDER')
    $class = 'ot_loworderfee';
  elseif ($sort_order_query->fields['configuration_key'] == 'MODULE_ORDER_TOTAL_GV_SORT_ORDER')
    $class = 'ot_gv';
  elseif ($sort_order_query->fields['configuration_key'] == 'MODULE_ORDER_TOTAL_TOTAL_SORT_ORDER')
    $class = 'ot_total';
  else $class = 'ot_custom';
    $sort_orders[] = array('id' => $sort_order_query->fields['configuration_key'],
                            'class' => $class,
                            'value' => $sort_order_query->fields['configuration_value']);
    $sort_order_query -> MoveNext();
  }
// JTD:10/19/05 - end of additions for proper sort order support

$action = (isset($_GET['action']) ? $_GET['action'] : 'edit');


///////////////////////////
// Begin page processing //
///////////////////////////

//UPDATE_INVENTORY_QUANTITY_START
$order_query = $db -> Execute("select products_id, products_quantity from " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int)$oID . "'");

  if (zen_not_null($action)) {

    // Split Order before applying edits (if applicable)
    if (isset($_POST['split_products']) && zen_not_null($_POST['split_products'])) {
      // Duplicate order details
      // "orders" table
      $old_order = $db->Execute("SELECT * FROM " . TABLE_ORDERS. " WHERE orders_id = '" . $oID . "'");
      while (!$old_order->EOF) {
        $new_order = array('customers_id' => $old_order->fields['customers_id'],
                           'customers_name' => $old_order->fields['customers_name'],
                           'customers_company' => $old_order->fields['customers_company'],
                           'customers_street_address' => $old_order->fields['customers_street_address'],
                           'customers_suburb' => $old_order->fields['customers_suburb'],
                           'customers_city' => $old_order->fields['customers_city'],
                           'customers_postcode' => $old_order->fields['customers_postcode'],
                           'customers_state' => $old_order->fields['customers_state'],
                           'customers_country' => $old_order->fields['customers_country'],
                           'customers_telephone' => $old_order->fields['customers_telephone'],
                           'customers_email_address' => $old_order->fields['customers_email_address'],
                           'customers_address_format_id' => $old_order->fields['customers_address_format_id'],
                           'delivery_name' => $old_order->fields['delivery_name'],
                           'delivery_company' => $old_order->fields['delivery_company'],
                           'delivery_street_address' => $old_order->fields['delivery_street_address'],
                           'delivery_suburb' => $old_order->fields['delivery_suburb'],
                           'delivery_city' => $old_order->fields['delivery_city'],
                           'delivery_postcode' => $old_order->fields['delivery_postcode'],
                           'delivery_state' => $old_order->fields['delivery_state'],
                           'delivery_country' => $old_order->fields['delivery_country'],
                           'delivery_address_format_id' => $old_order->fields['delivery_address_format_id'],
                           'billing_name' => $old_order->fields['billing_name'],
                           'billing_company' => $old_order->fields['billing_company'],
                           'billing_street_address' => $old_order->fields['billing_street_address'],
                           'billing_suburb' => $old_order->fields['billing_suburb'],
                           'billing_city' => $old_order->fields['billing_city'],
                           'billing_postcode' => $old_order->fields['billing_postcode'],
                           'billing_state' => $old_order->fields['billing_state'],
                           'billing_country' => $old_order->fields['billing_country'],
                           'billing_address_format_id' => $old_order->fields['billing_address_format_id'],
                           'payment_method' => $old_order->fields['payment_method'],
                           'payment_module_code' => $old_order->fields['payment_module_code'],
                           'shipping_method' => $old_order->fields['shipping_method'],
                           'shipping_module_code' => $old_order->fields['shipping_module_code'],
                           'coupon_code' => $old_order->fields['coupon_code'],
                           'cc_type' => $old_order->fields['cc_type'],
                           'cc_owner' => $old_order->fields['cc_owner'],
                           'cc_number' => $old_order->fields['cc_number'],
                           'cc_expires' => $old_order->fields['cc_expires'],
                           'cc_cvv' => $old_order->fields['cc_cvv'],
                           'last_modified' => 'now()',
                           'date_purchased' => $old_order->fields['date_purchased'],
                           'orders_status' => $old_order->fields['orders_status'],
                           'orders_date_finished' => $old_order->fields['orders_date_finished'],
                           'currency' => $old_order->fields['currency'],
                           'currency_value' => $old_order->fields['currency_value'],
                           'order_total' => $old_order->fields['order_total'],
                           'order_tax' => $old_order->fields['order_tax']);

        zen_db_perform(TABLE_ORDERS, $new_order);

        $old_order->MoveNext();
      }

      // get new order ID to use with other split actions
      $new_order_id = mysql_insert_id();
      $messageStack->add_session('New order ID: ' . $new_order_id, 'warning');

      // "orders_status_history" table
      $old_order_status_history = $db->Execute("SELECT * FROM " . TABLE_ORDERS_STATUS_HISTORY . " WHERE orders_id = '" . $oID . "'");
      while (!$old_order_status_history->EOF) {
        $new_order_status_history = array('orders_id' => $new_order_id,
                                          'orders_status_id' => $old_order_status_history->fields['orders_status_id'],
                                          'date_added' => $old_order_status_history->fields['date_added'],
                                          'customer_notified' => $old_order_status_history->fields['customer_notified'],
                                          'comments' => $old_order_status_history->fields['comments']);

        zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $new_order_status_history);

        $old_order_status_history->MoveNext();
      }

      // "orders_total" table
      $old_order_total = $db->Execute("SELECT * FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '" . $oID . "' ORDER BY sort_order");
      while (!$old_order_total->EOF) {
        $new_order_total = array('orders_id' => $new_order_id,
                                 'title' => $old_order_total->fields['title'],
                                 'text' => $old_order_total->fields['text'],
                                 'value' => $old_order_total->fields['value'],
                                 'class' => $old_order_total->fields['class'],
                                 'sort_order' => $old_order_total->fields['sort_order']);

        zen_db_perform(TABLE_ORDERS_TOTAL, $new_order_total);

        $old_order_total->MoveNext();
      }


      // Reassign affected products to new order
      $split_products = $_POST['split_products'];
      foreach($split_products as $orders_products_id) {
        $db->Execute("UPDATE " . TABLE_ORDERS_PRODUCTS . " SET
                      orders_id = '" . $new_order_id . "'
                      WHERE orders_products_id = '" . $orders_products_id . "'");

        $db->Execute("UPDATE " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " SET
                      orders_id = '" . $new_order_id . "'
                      WHERE orders_products_id = '" . $orders_products_id . "'");

        $db->Execute("UPDATE " . TABLE_ORDERS_PRODUCTS_DOWNLOAD . " SET
                      orders_id = '" . $new_order_id . "'
                      WHERE orders_products_id = '" . $orders_products_id . "'");

      }

      // recalculate totals on both orders
      recalc_total($oID);
      recalc_total($new_order_id);

      // add history comments to both orders reflecting the split
      $notify_split = (isset($_POST['notify_split']) ? 1 : 0);

      // entry for original order
      $db->Execute("INSERT INTO " . TABLE_ORDERS_STATUS_HISTORY . "
                   (orders_id, orders_status_id, date_added, customer_notified, comments)
                   VALUES ('" . $oID . "',
                   '" . $new_order['orders_status'] . "',
                   now(),
                   '" . $notify_split . "',
                   '" . COMMENTS_SPLIT_OLD . $new_order_id . "')");

      // entry for new order
      $db->Execute("INSERT INTO " . TABLE_ORDERS_STATUS_HISTORY . "
                   (orders_id, orders_status_id, date_added, customer_notified, comments)
                   VALUES ('" . $new_order_id . "',
                   '" . $new_order['orders_status'] . "',
                   now(),
                   '" . $notify_split . "',
                   '" . COMMENTS_SPLIT_NEW . $oID . "')");

      // notify customer (if selected)
      if ($notify_split) {
        email_latest_status($oID, $orders_status_array);
      }

      // redirect to details page for new order
      zen_redirect(zen_href_link(FILENAME_SUPER_ORDERS, 'oID='. $new_order_id . '&action=edit', 'NONSSL'));
    }

    switch ($action) {

	// Update Order
	case 'update_order':

		// Update Order Info
		$UpdateOrders = "UPDATE " . TABLE_ORDERS . " SET
			customers_id = '" . zen_db_prepare_input($_POST['update_customer_id']) . "',
			customers_name = '" . zen_db_prepare_input($_POST['update_customer_name']) . "',
			customers_company = '" . zen_db_prepare_input($_POST['update_customer_company']) . "',
			customers_street_address = '" . zen_db_prepare_input($_POST['update_customer_street_address']) . "',
			customers_suburb = '" . zen_db_prepare_input($_POST['update_customer_suburb']) . "',
			customers_city = '" . zen_db_prepare_input($_POST['update_customer_city']) . "',
			customers_state = '" . zen_db_prepare_input($_POST['update_customer_state']) . "',
			customers_postcode = '" . zen_db_input($_POST['update_customer_postcode']) . "',
			customers_country = '" . zen_db_prepare_input($_POST['update_customer_country']) . "',
			customers_telephone = '" . zen_db_prepare_input($_POST['update_customer_telephone']) . "',
			customers_email_address = '" . zen_db_prepare_input($_POST['update_customer_email_address']) . "',";
		
		//if ($_POST['same_billing'] == 1) {
		$UpdateOrders .= "billing_name = '" . zen_db_prepare_input($_POST['update_billing_name']) . "',
			billing_company = '" . zen_db_prepare_input($_POST['update_billing_company']) . "',
			billing_street_address = '" . zen_db_prepare_input($_POST['update_billing_street_address']) . "',
			billing_suburb = '" . zen_db_prepare_input($_POST['update_billing_suburb']) . "',
			billing_city = '" . zen_db_prepare_input($_POST['update_billing_city']) . "',
			billing_state = '" . zen_db_prepare_input($_POST['update_billing_state']) . "',
			billing_postcode = '" . zen_db_prepare_input($_POST['update_billing_postcode']) . "',
			billing_country = '" . zen_db_prepare_input($_POST['update_billing_country']) . "',";
		//}

		$UpdateOrders .= "delivery_name = '" . zen_db_prepare_input($_POST['update_delivery_name']) . "',
			delivery_company = '" . zen_db_prepare_input($_POST['update_delivery_company']) . "',
			delivery_street_address = '" . zen_db_prepare_input($_POST['update_delivery_street_address']) . "',
			delivery_suburb = '" . zen_db_prepare_input($_POST['update_delivery_suburb']) . "',
			delivery_city = '" . zen_db_prepare_input($_POST['update_delivery_city']) . "',
			delivery_state = '" . zen_db_prepare_input($_POST['update_delivery_state']) . "',
			delivery_postcode = '" . zen_db_prepare_input($_POST['update_delivery_postcode']) . "',
			delivery_country = '" . zen_db_prepare_input($_POST['update_delivery_country']) . "',
			cc_type = '" . zen_db_prepare_input($_POST['update_info_cc_type']) . "',
			cc_owner = '" . zen_db_prepare_input($_POST['update_info_cc_owner']) . "',";

                //Update Payment Method
                if ($order->info['payment_method'] != $_POST['update_payment_method']) {
                  $update_payment_module_code = $db->Execute("SELECT DISTINCT payment_method, payment_module_code
                                                              FROM " . TABLE_ORDERS . "
                                                              ORDER BY payment_method ASC");
                  while (!$update_payment_module_code->EOF) {
                    if ($_POST['update_payment_method'] == $update_payment_module_code->fields['payment_method']) {
                      $UpdateOrders .= "payment_module_code = '" . $update_payment_module_code->fields['payment_module_code'] . "',
                                        payment_method = '" . $_POST['update_payment_method'] . "', ";
                    }
                    $update_payment_module_code->MoveNext();
                  }

                  // clear credit card history
                  $db->Execute("UPDATE " . TABLE_ORDERS . " SET
                                cc_type = '',
                                cc_owner = '',
                                cc_number = '',
                                cc_expires = '',
                                cc_cvv = ''
                                WHERE orders_id = '" . $oID . "'");

                  // clear PO history
                  $db->Execute("DELETE FROM " . TABLE_PAYMENT_PURCHASE_ORDER . " WHERE orders_id = '" . $oID . "'");

                  // clear check history
                  $db->Execute("DELETE FROM " . TABLE_PAYMENT_CHECK . " WHERE orders_id = '" . $oID . "'");
                  $db->Execute("DELETE FROM " . TABLE_PAYMENT_CHECK_BALANCE . " WHERE orders_id = '" . $oID . "'");

                  // Add notice to output
                  $messageStack->add_session('Payment method changed from "' . $order->info['payment_method'] . '" to "' . $_POST['update_payment_method'] . '"', 'warning');
                }

		if (substr($update_info_cc_number, 0, 8) != "(Last 4)") {
		  $UpdateOrders .= "cc_number = '". $_POST['update_info_cc_number']. "',";
		}

                if ($_POST['update_info_cc_cvv'] != '') {
		  $UpdateOrders .= "cc_cvv = '". $_POST['update_info_cc_cvv']. "',";
		}

		$UpdateOrders .= "cc_expires = '". $_POST['update_info_cc_expires']. "'";

		$UpdateOrders .= " WHERE orders_id = '" . zen_db_input($oID) . "';";

		$db->Execute($UpdateOrders);
		$order_updated = true;


		// Update Status History fields
                $update_status_history = $db->Execute("SELECT * FROM " . TABLE_ORDERS_STATUS_HISTORY . "
                                                       WHERE orders_id = '" . $oID . "'
                                                       ORDER BY orders_status_history_id DESC");

                while (!$update_status_history->EOF) {
                  $this_history_id = $update_status_history->fields['orders_status_history_id'];
                  $this_status = $_POST['status_' . $this_history_id];
                  $this_comments = $_POST['comments_' . $this_history_id];
                  $this_delete = $_POST['delete_' . $this_history_id];

                  if (isset($this_delete) || $this_delete == '1') {
                    $db->Execute("DELETE FROM " . TABLE_ORDERS_STATUS_HISTORY . "
                                  WHERE orders_status_history_id = '" . $this_history_id . "'");

                    $messageStack->add_session(WARNING_STATUS_HISTORY_DELETED .
                    '<b>' . $orders_status_array[$update_status_history->fields['orders_status_id']] . '</b>', 'warning');
                  }

                  if ($this_status != $update_status_history->fields['orders_status_id']) {
                    $update_query = "UPDATE " . TABLE_ORDERS_STATUS_HISTORY . "
                                     SET orders_status_id = '" . $this_status . "'
                                     WHERE orders_status_history_id  = '" . $this_history_id . "'";
                    $execute_update_query = $db->Execute($update_query);
                  }

                  if ($this_comments != $update_status_history->fields['comments']) {
                    $update_query = "UPDATE " . TABLE_ORDERS_STATUS_HISTORY . "
                                     SET comments = '" . $this_comments . "'
                                     WHERE orders_status_history_id  = '" . $this_history_id . "'";
                    $execute_update_query = $db->Execute($update_query);
                  }

                  $update_status_history->MoveNext();
                }

                // Requery the orders_status_history table and reset the
                // current status and modify date in the orders table
                $update_status_history = $db->Execute("SELECT * FROM " . TABLE_ORDERS_STATUS_HISTORY . "
                                                       WHERE orders_id = '" . $oID . "'
                                                       ORDER BY orders_status_history_id DESC");

                $db->Execute("UPDATE " . TABLE_ORDERS . " SET
                              orders_status = '" . $update_status_history->fields['orders_status_id'] . "',
                              last_modified = '" . $update_status_history->fields['date_added'] . "'
                              WHERE orders_id = '" . $oID . "'");



                // Update Purchase Order Info
                if ($_POST['update_purchase_order'] == 1) {
                  $po_number = zen_db_prepare_input($_POST['po_number']);

                  $data_compare = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_PURCHASE_ORDER . "
                                                WHERE orders_id = '" . $oID . "'");

                  if ($po_number != $data_compare->fields['po_number']) {

                    if ($po_number == '') {
                      $db->Execute("DELETE FROM " . TABLE_PAYMENT_PURCHASE_ORDER . " WHERE orders_id = '" . $oID . "'");
                      $messageStack->add_session('Warning: PO information for Order #' . $oID . ' has been removed.', 'warning');
                    }
                    else {
                    $db->Execute("UPDATE " . TABLE_PAYMENT_PURCHASE_ORDER . " SET
                                  po_number = '" . $po_number . "',
                                  last_modified = now()
                                  WHERE orders_id = '" . $oID . "'");
                    }
                  }
                }


                // Update Check info
                if ($_POST['update_check'] == 1) {
                  $check_number = zen_db_prepare_input($_POST['check_number']);
                  $check_name = zen_db_prepare_input($_POST['check_name']);
                  $check_amount = zen_db_prepare_input($_POST['check_amount']);

                  $data_compare = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK . "
                                                WHERE orders_id = '" . $oID . "'");

                  if ($check_number != $data_compare->fields['check_number'] || $check_name != $data_compare->fields['check_name'] || $check_amount != $data_compare->fields['check_amount']) {

                    if ($check_number == '' && $check_name == '' && $check_amount == '') {
                      $db->Execute("DELETE FROM " . TABLE_PAYMENT_CHECK . " WHERE orders_id = '" . $oID . "'");
                      $messageStack->add_session('Warning: Check information for Order #' . $oID . ' has been removed.', 'warning');
                    }
                    else {
                      $db->Execute("UPDATE " . TABLE_PAYMENT_CHECK . " SET
                                    check_number = '" . $check_number . "',
                                    check_name = '" . $check_name . "',
                                    check_amount = '" . $check_amount . "',
                                    last_modified = now()
                                    WHERE orders_id = '" . $oID . "'");
                    }
                  }
                }


                // Update Balancing Check Info
                if ($_POST['update_balance_check'] == 1) {
                  $balance_check_number = zen_db_prepare_input($_POST['balance_check_number']);
                  $balance_check_name = zen_db_prepare_input($_POST['balance_check_name']);
                  $check_index = $_POST['check_index'];

                  $data_compare = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK_BALANCE . "
                                                WHERE orders_id = '" . $oID . "'");

                  if ($balance_check_number != $data_compare->fields['check_number'] || $balance_check_name != $data_compare->fields['check_name']) {

                    if ($balance_check_number == '' && $balance_check_name == '') {
                      $db->Execute("DELETE FROM " . TABLE_PAYMENT_CHECK_BALANCE . " WHERE check_index = '" . $check_index . "'");
                      $messageStack->add_session('Warning: Secondary check information for Order #' . $oID . ' has been removed.', 'warning');
                    }
                    else {
                      $db->Execute("UPDATE " . TABLE_PAYMENT_CHECK_BALANCE . " SET
                                    check_number = '" . $balance_check_number . "',
                                    check_name = '" . $balance_check_name . "',
                                    last_modified = now()
                                    WHERE check_index = '" . $check_index . "'");
                    }
                  }
                }

                // Update the balance_status field in TABLE_PAYMENT_CHECK
                // based on changes to the check data
                $balance_check_exists = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK_BALANCE . "
                                                      WHERE check_index = '" . $check_index . "'");
                if (zen_not_null($balance_check_exists->fields['check_index'])) {
                  $new_balance_status = 2;
                }
                else {
                  $check_data = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK . " WHERE orders_id = '" . $oID . "'");
                  $totals = $db->Execute("SELECT value FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '" . $oID . "' AND class = 'ot_total'");
                  if ($check_data->fields['check_amount'] == $totals->fields['value']) {
                    $new_balance_status = 0;
                  }
                  else {
                    $new_balance_status = 1;
                  }
                }
                $db->Execute("UPDATE " . TABLE_PAYMENT_CHECK . " SET
                              balance_status = '" . $new_balance_status . "'
                              WHERE orders_id = '" . $oID . "'");


	// Update Products
        $ot_value = 0;
        $ot_class = '';
	    $RunningSubTotal = 0;
	    $RunningTax = 0;
        $update_products = $_POST['update_products'];

		foreach($update_products as $orders_products_id => $products_details) {
			// Update orders_products Table
			#$order = zen_db_fetch_array($order_query);
			if ($products_details["qty"] != $order_query->fields['products_quantity']){
				$differenza_quantita = ($products_details["qty"] - $order_query->fields['products_quantity']);
					$db -> Execute("update " . TABLE_PRODUCTS . " set products_quantity = products_quantity - " . $differenza_quantita . ", products_ordered = products_ordered + " . $differenza_quantita . " where products_id = '" . (int)$order_query->fields['products_id'] . "'");
			}

			if($products_details["qty"] > 0) {
				$Query = "UPDATE " . TABLE_ORDERS_PRODUCTS . " SET
					products_model = '" . $products_details["model"] . "',
					products_name = '" . str_replace("'", "\'", $products_details["name"]) . "',
					final_price = '" . $products_details["final_price"] . "',
					products_tax = '" . $products_details["tax"] . "',
					products_quantity = '" . $products_details["qty"] . "'
					WHERE orders_products_id = '" . $orders_products_id . "'";
				$db->Execute($Query);
                        	
				// Update Tax and Subtotals
				$RunningSubTotal += $products_details["qty"] * $products_details["final_price"];
				$RunningTax += (($products_details["tax"]/100) * ($products_details["qty"] * $products_details["final_price"]));
                        	
				// Update Any Attributes
				if (IsSet($products_details[attributes])) {
					foreach($products_details["attributes"] as $orders_products_attributes_id => $attributes_details) {
						$Query = "UPDATE " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " SET
							products_options = '" . $attributes_details["option"] . "',
							products_options_values = '" . $attributes_details["value"] . "'
							WHERE orders_products_attributes_id = '" . $orders_products_attributes_id . "'";
						$db->Execute($Query);
					}
				}
			}
			else {
				// 0 Quantity = Delete
				$Query = "DELETE FROM " . TABLE_ORDERS_PRODUCTS . " WHERE orders_products_id = '" . $orders_products_id . "'";
				$db->Execute($Query);

                //UPDATE_INVENTORY_QUANTITY_START
                   #$order = zen_db_fetch_array($order_query);
                    if ($products_details["qty"] != $order_query->fields['products_quantity']) {
                     $differenza_quantita = ($products_details["qty"] - $order_query->fields['products_quantity']);
                     $db -> Execute("update " . TABLE_PRODUCTS . " set products_quantity = products_quantity - " . $differenza_quantita . ", products_ordered = products_ordered + " . $differenza_quantita . " where products_id = '" . (int)$order_query->fields['products_id'] . "'");
                    }
				//UPDATE_INVENTORY_QUANTITY_END

				$Query = "DELETE FROM " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " WHERE orders_products_id = '" . $orders_products_id . "'";
				$db->Execute($Query);
			}
                        $order_query->MoveNext();
		}

		// Shipping Tax
              $update_totals = array();   // JTD:02/06/06 - Grayson, fix warnings
               $update_totals = $_POST['update_totals'];
			foreach($update_totals as $total_index => $total_details) {
				extract($total_details, EXTR_PREFIX_ALL, "ot");
				if($ot_class == "ot_shipping") {
					$RunningTax += (($AddShippingTax / 100) * $ot_value);
				}
			}

		// Update Totals
			$RunningTotal = 0;
            // JTD:10/21/05 - moved this check down as it was being called before $update_totals was set by post
            // CWS EDIT (start) -- Check for existence of subtotals...
     		$ot_subtotal_found = false;
        	foreach($update_totals as $total_details)
    		{
    		    extract($total_details,EXTR_PREFIX_ALL,"ot");
    			if($ot_class == "ot_subtotal")
    			{
    			    $ot_subtotal_found = true;
        			break;
    			}
            }

			// Does pre-check for Tax field existence and assigns proper values to $update_totals array
            // 'class' and 'sort_order' elements so as to support added 'ot_custom' entries. JTD:11/21/05
			$ot_tax_found = 0;
            $i = 0;
			foreach($update_totals as $total_details)
			{
				extract($total_details,EXTR_PREFIX_ALL,"ot");

				if($ot_class == "ot_tax")
					$ot_tax_found = 1;
                else if($ot_class == "ot_custom")   // JTD:10/21/05 - support for adding an ot_xxxxx record when the order did not originally have it.
                        {
                        if (strncasecmp($ot_title, 'Discount Coupon', 15) >= 0)
                            {
                            // JTD:10/21/05 - Here a coupon has been added to an order that previously had no coupon
                            // associated with it.
                            $ot_class = "ot_coupon";
                            $update_totals[$i]['class'] = $ot_class;
                            $update_totals[$i]['sort_order'] = zen_get_sort_order($ot_class);
                            }
                        // JTD:10/24/05 - new, support for adding shipping to an order which previously had none re: Festus
                        if (strncasecmp($ot_title, 'Shipping', 8) >= 0)
                            {
                            // JTD:10/24/05 - Here shipping has been added to an order that previously had no shipping
                            // associated with it.
                            $ot_class = "ot_shipping";
                            $update_totals[$i]['class'] = $ot_class;
                            $update_totals[$i]['sort_order'] = zen_get_sort_order($ot_class);
                            }
                        if (strncasecmp($ot_title, 'Insurance', 9) >= 0)
                            {
                            $ot_class = "ot_shipping";
                            $update_totals[$i]['class'] = $ot_class;
                            $update_totals[$i]['sort_order'] = zen_get_sort_order($ot_class);
                            }
                        if (strncasecmp($ot_title, 'Gift Voucher', 12) >= 0)
                            {
                            $ot_class = "ot_gv";
                            $update_totals[$i]['class'] = $ot_class;
                            $update_totals[$i]['sort_order'] = zen_get_sort_order($ot_class);
                            }
                        if (strncasecmp($ot_title, 'Group Discount', 14) >= 0)
                            {
                            $ot_class = "ot_group_pricing";
                            $update_totals[$i]['class'] = $ot_class;
                            $update_totals[$i]['sort_order'] = zen_get_sort_order($ot_class);
                            }
                        }
            ++$i;
			}

            // JTD:11/21/05 - modified this loop to respect the sort_order of order total items to insure that
            // order total records are processed in the correct order, regardless of the 'orders_total_id'.
            // i.e., the order that they exist in TABLE_ORDERS_TOTAL.
            // The key to all this working is the below array sort which sorts the array by configuration 'sort_order'
            array_multisort($update_totals,SORT_ASC);
			foreach($update_totals as $total_index => $total_details)
			{
				extract($total_details,EXTR_PREFIX_ALL,"ot");

//				if( trim(strtolower($ot_title)) == "tax" || trim(strtolower($ot_title)) == "tax:" )
                if (($ot_title == "") && ($RunningTax > 0))   // JTD:10/20/05 - fix for adding tax to a product
				{
					if($ot_class != "ot_tax" && $ot_tax_found == 0)
					{
						// Inserting Tax
						$ot_class = "ot_tax";
						$ot_value = "x"; // This gets updated in the next step
                        $ot_title = "State Sales Tax:"; // JTD:10/20/05 - fix for adding tax to a product
						$ot_tax_found = 1;
					}
				}
				// JTD:10/20/05 - added to delete aqn existing order total ot_tax record if tax is zero
				else if (($RunningTax == 0) && ($ot_class == "ot_tax"))
                    {
                    $ot_title = "";
                    $ot_value = "";
                    }


				if( trim($ot_title) && trim($ot_value) )
    				{
					// Update ot_subtotal, ot_tax, and ot_total classes
					if($ot_class == "ot_subtotal")
					    $ot_value = $RunningSubTotal;

                    elseif($ot_class == "ot_tax")
						$ot_value = $RunningTax;

                    elseif($ot_class == "ot_total")
                        {
                        $ot_value = $RunningTotal;
                        if ( !$ot_subtotal_found )
                            {
                            // There was no subtotal on this order, lets add the running subtotal in.
                            $ot_value += $RunningSubTotal;
                            }
                        }

                    if(($ot_class == "ot_coupon") || ($ot_class == "ot_gv") || ($ot_class == "ot_group_pricing"))        // JTD:10/19/05 - begin added for coupon support
                        {
                        $RunningSubTotal -= $ot_value;
                     	$RunningTotal -= $ot_value;
                       // decrement tax by coupon amount
                        $RunningTax -= (($products_details["tax"]/100) * $ot_value);
                    	$ot_text = '-' . $currencies->format($ot_value, true, $order->info['currency'], $order->info['currency_value']);
                        }
                    else                               // JTD:10/19/05 - end added for coupon support
                        {
                        $RunningTotal += $ot_value;
                        $ot_text = $currencies->format($ot_value, true, $order->info['currency'], $order->info['currency_value']);
                        }

    				$sort_order = zen_get_sort_order($ot_class);

                    if($ot_total_id > 0)
					    {
						// In Database Already - Update
						$Query = "UPDATE " . TABLE_ORDERS_TOTAL . " SET
                                                          title = '" . $ot_title . "',
                                                          text = '" . $ot_text . "',
                                                          value = '" . $ot_value . "',
                                                          sort_order = '" . $sort_order . "'
                                                          WHERE orders_total_id = '" . $ot_total_id . "'";
						$db->Execute($Query);
					}
					else {

						// New Insert
						$Query = "INSERT INTO " . TABLE_ORDERS_TOTAL . " SET
						          orders_id = '" . $oID . "',
						          title = '" . $ot_title . "',
						          text = '" . $ot_text . "',
						          value = '" . $ot_value . "',
						          class = '" . $ot_class . "',
						          sort_order = '" . $sort_order . "'";
						$db->Execute($Query);
					}


                    }
				elseif($ot_total_id > 0)
				    {
					// Delete Total Piece
					$Query = "DELETE FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_total_id = '" . $ot_total_id . "'";
					$db -> Execute($Query);
				    }

			}


		if ($order_updated) {
			$messageStack->add_session(SUCCESS_ORDER_UPDATED, 'success');
		}
                zen_redirect(zen_href_link(FILENAME_SUPER_ORDERS, zen_get_all_get_params(array('action')) . 'action=edit', 'NONSSL'));

	break;

	// Add a Product
	case 'add_product':
		if($step == 5) {
			// Get Order Info
			$oID = zen_db_prepare_input($_GET['oID']);
			$order = new order($oID);

			$AddedOptionsPrice = 0;

			// Get Product Attribute Info
			if(IsSet($add_product_options)) {
				foreach($add_product_options as $option_id => $option_value_id) {
					$result = $db -> Execute("SELECT * FROM " . TABLE_PRODUCTS_ATTRIBUTES . " pa LEFT JOIN " . TABLE_PRODUCTS_OPTIONS . " po ON po.products_options_id=pa.options_id LEFT JOIN " . TABLE_PRODUCTS_OPTIONS_VALUES . " pov ON pov.products_options_values_id=pa.options_values_id WHERE products_id='$add_product_products_id' and options_id=$option_id and options_values_id=$option_value_id and po.language_id = '" . (int)$_SESSION['languages_id'] . "' and pov.language_id = '" . (int)$_SESSION['languages_id'] . "'");
                                        // Do we need this?
					###r.1. $row = tep_db_fetch_array($result);
                                        $row = $result->fields;

					extract($row, EXTR_PREFIX_ALL, "opt");
					$AddedOptionsPrice += $opt_options_values_price;
					$option_value_details[$option_id][$option_value_id] = array ("options_values_price" => $opt_options_values_price);
					$option_names[$option_id] = $opt_products_options_name;
					$option_values_names[$option_value_id] = $opt_products_options_values_name;
				}
			}

			// Get Product Info
			$InfoQuery = "select p.products_model,p.products_price,pd.products_name,p.products_tax_class_id from " . TABLE_PRODUCTS . " p left join " . TABLE_PRODUCTS_DESCRIPTION . " pd on pd.products_id=p.products_id where p.products_id='$add_product_products_id' and pd.language_id = '" . (int)$_SESSION['languages_id'] . "'";
			$result = $db->Execute($InfoQuery);
			#$row = zen_db_fetch_array($result);
			extract($result->fields, EXTR_PREFIX_ALL, "p");
			
			// Following functions are defined at the bottom of this file
			$CountryID = zen_get_country_id($order->delivery["country"]);
			$ZoneID = zen_get_zone_id($CountryID, $order->delivery["state"]);
			
			$ProductsTax = zen_get_tax_rate($p_products_tax_class_id, $CountryID, $ZoneID);
			
			$Query = "insert into " . TABLE_ORDERS_PRODUCTS . " set
				orders_id = $oID,
				products_id = $add_product_products_id,
				products_model = '$p_products_model',
				products_name = '" . str_replace("'", "&#39;", $p_products_name) . "',
				products_price = '$p_products_price',
				final_price = '" . ($p_products_price + $AddedOptionsPrice) . "',
				products_tax = '$ProductsTax',
				products_quantity = $add_product_quantity;";
			$db -> Execute($Query);
			$new_product_id = zen_db_insert_id();

			//UPDATE INVENTORY QUANTITY
			$db -> Execute("UPDATE " . TABLE_PRODUCTS . " SET products_quantity = products_quantity - " . $add_product_quantity . ", products_ordered = products_ordered + " . $add_product_quantity . " where products_id = '" . $add_product_products_id . "'");

			if(IsSet($add_product_options))
			{
				foreach($add_product_options as $option_id => $option_value_id)
				{
					$Query = "INSERT INTO " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " SET
						orders_id = $oID,
						orders_products_id = $new_product_id,
						products_options = '" . $option_names[$option_id] . "',
						products_options_values = '" . $option_values_names[$option_value_id] . "',
						options_values_price = '" . $option_value_details[$option_id][$option_value_id]["options_values_price"] . "',
						price_prefix = '+';";
					$db -> Execute($Query);
				}
			}
			
			// Calculate Tax and Sub-Totals
			$RunningSubTotal = 0;
			$RunningTax = 0;

			for ($i=0; $i<sizeof($order->products); $i++) {
			  $RunningSubTotal += ($order->products[$i]['qty'] * $order->products[$i]['final_price']);
			  $RunningTax += (($order->products[$i]['tax'] / 100) * ($order->products[$i]['qty'] * $order->products[$i]['final_price']));
			}
			
            // Tax
			$Query = "update " . TABLE_ORDERS_TOTAL . " set
				text = '\$" . number_format($RunningTax, 2, '.', ',')  . "',
				value = '" . $RunningTax . "'
				where class='ot_tax' and orders_id=$oID";
			$db -> Execute($Query);

			// Sub-Total
			$Query = "update " . TABLE_ORDERS_TOTAL . " set
				text = '\$" . number_format($RunningSubTotal + $RunningTax, 2, '.', ',') . "',
				value = '" . $RunningSubTotal . "'
				where class='ot_subtotal' and orders_id=$oID";
			$db -> Execute($Query);

			// Total
			$Query = "select sum(value) as total_value from " . TABLE_ORDERS_TOTAL . " where class != 'ot_total' and orders_id=$oID";
			$result = $db -> Execute($Query);
			$Total = $result->fields["total_value"];

			$Query = "update " . TABLE_ORDERS_TOTAL . " set
				text = '\$" . number_format($Total, 2, '.', ',') . "',
				value = '" . $Total . "'
				where class='ot_total' and orders_id=$oID";
			$db -> Execute($Query);

			zen_redirect(zen_href_link("super_edit.php", zen_get_all_get_params(array('action')) . 'action=edit'));
		}
	break;
    }
  }

  if (($action == 'edit') && isset($_GET['oID'])) {
    $oID = zen_db_prepare_input($_GET['oID']);

    $orders_query = $db -> Execute("SELECT orders_id FROM " . TABLE_ORDERS . " WHERE orders_id = '" . (int)$oID . "'");
    $order_exists = true;
    if (!$orders_query->RecordCount()) {
      $order_exists = false;
      $messageStack->add(sprintf(ERROR_ORDER_DOES_NOT_EXIST, $oID), 'error');
    }
  }
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<link rel="stylesheet" type="text/css" href="includes/cssjsmenuhover.css" media="all" id="hoverJS">
<script language="javascript" src="includes/menu.js"></script>
<script language="javascript" src="includes/general.js"></script>
<script type="text/javascript">
  <!--
  function init()
  {
    cssjsmenu('navbar');
    if (document.getElementById)
    {
      var kill = document.getElementById('hoverJS');
      kill.disabled = true;
    }
  }
  // -->
</script>
</head>
<body onload="init()">
<!-- header //-->
<?php
  require(DIR_WS_INCLUDES . 'header.php');
?>
<!-- header_eof //-->

<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
<?php
  if (($action == 'edit') && ($order_exists == true)) {
    $order = new order($oID);

    if ($order->delivery['name'] != $order->billing['name'] && $order->delivery['name'] != '') {
      $same_billing = 0;
    }
    else {
      $same_billing = 0;
      // ^ CHANGE TO "1" TO ONLY SHOW BILLING WHEN DIFFERENT
    }
    zen_draw_hidden_field('same_billing', $same_billing);

    $prev_oID = $oID - 1;
    $next_oID = $oID + 1;

    $prev_button = '            <FORM><INPUT TYPE="BUTTON" VALUE="<<< ' . $prev_oID . '" ONCLICK="window.location.href=\'' . zen_href_link(FILENAME_SUPER_EDIT, 'oID=' . $prev_oID) . '\'"></FORM>';

    $check_for_next = $db->Execute("SELECT * FROM " . TABLE_ORDERS . " WHERE orders_id = '" . (int)$next_oID . "'");
    if (zen_not_null($check_for_next->fields['orders_id'])) {
      $next_button = '            <FORM><INPUT TYPE="BUTTON" VALUE="' . $next_oID . ' >>>" ONCLICK="window.location.href=\'' . zen_href_link(FILENAME_SUPER_EDIT, 'oID=' . $next_oID) . '\'"></FORM>';
    }
    else {
      $next_button = '            <FORM><INPUT TYPE="BUTTON" VALUE="' . BUTTON_TO_LIST . '" ONCLICK="window.location.href=\'' . zen_href_link(FILENAME_SUPER_ORDERS) . '\'"></FORM>';
    }

    $orders_id_array = $db->Execute("SELECT orders_id FROM " . TABLE_ORDERS);
    while (!$orders_id_array->EOF) {
      $orders_id_list[] = array('id' => $orders_id_array->fields['orders_id'],
                                'text' => $orders_id_array->fields['orders_id']);
      $orders_id_array->MoveNext();
    }
?>

      <tr>
        <td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo HEADING_TITLE . ' #' . $oID; ?></td>
            <td class="main" align="center" valign="middle"><?php echo $prev_button; ?></td>
            <td class="smallText" align="center" valign="center"><?php
              echo SELECT_ORDER_LIST . '<br>';
              echo zen_draw_form('search_oid', FILENAME_SUPER_EDIT, '', 'get', '', true);
              echo zen_draw_pull_down_menu('oID', $orders_id_list, '', 'onChange="this.form.submit();"');
              echo zen_draw_hidden_field('action', 'edit');
              echo '</form>';
            ?></td>
            <td class="main" align="center" valign="middle"><?php echo $next_button; ?></td>
            <td class="pageHeading" align="right"><?php echo zen_draw_separator('pixel_trans.gif', 1, HEADING_IMAGE_HEIGHT); ?></td>
            <td align="right"><?php
              echo '<a href="' . zen_href_link(FILENAME_SUPER_ORDERS, 'oID=' . $oID . '&action=edit', 'NONSSL') . '">' . zen_image_button('button_details.gif', IMAGE_EDIT) . '</a>&nbsp;&nbsp;';
              echo '<a href="' . zen_href_link(FILENAME_SUPER_INVOICE, 'oID=' . $_GET['oID']) . '" TARGET="_blank">' . zen_image_button('button_invoice.gif', IMAGE_ORDERS_INVOICE) . '</a>&nbsp;&nbsp;';
              echo '<a href="' . zen_href_link(FILENAME_SUPER_PACKINGSLIP, 'oID=' . $_GET['oID']) . '" TARGET="_blank">' . zen_image_button('button_packingslip.gif', IMAGE_ORDERS_PACKINGSLIP) . '</a>&nbsp;&nbsp;';
              echo '<a href="' . zen_href_link(FILENAME_SUPER_ORDERS, zen_get_all_get_params(array('action','referer'))) . '">' . zen_image_button('button_back.gif', IMAGE_BACK) . '</a>';
            ?></td>
          </tr>
          <tr>
            <td colspan="6"><?php echo zen_draw_separator(); ?></td>
          </tr>
        </table></td>
      </tr>

<!-- Begin Addresses Block -->
      <tr>
      <?php echo zen_draw_form('edit_order', FILENAME_SUPER_EDIT, zen_get_all_get_params(array('action')) . 'action=update_order'); ?>
      <td align="center"><table border="0" width="100%" cellspacing="0" cellpadding="0">
        <tr>
          <td align="center"><table border="0" width="100%" cellspacing="0" cellpadding="0">
            <tr>
              <td><table border="0" width="100%" cellspacing="0" cellpadding="2">
                <tr>
                  <td class="main">&nbsp;</td>
                  <td class="main"><b><?php echo ENTRY_CUSTOMER_ADDRESS; ?></b></td>
                </tr>
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_NAME; ?></td>
                  <td class="main"><input name="update_customer_name" size="25" value="<?php echo zen_html_quotes($order->customer['name']); ?>"></td>
                </tr>
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_COMPANY; ?></td>
                  <td class="main"><input name="update_customer_company" size="25" value="<?php echo zen_html_quotes($order->customer['company']); ?>"></td>
                </tr>
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_ADDRESS; ?></td>
                  <td class="main"><input name="update_customer_street_address" size="25" value="<?php echo zen_html_quotes($order->customer['street_address']); ?>"></td>
                </tr>
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_SUBURB; ?></td>
                  <td class="main"><input name="update_customer_suburb" size="25" value="<?php echo zen_html_quotes($order->customer['suburb']); ?>"></td>
                </tr>
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_CITY; ?></td>
                  <td class="main"><input name="update_customer_city" size="25" value="<?php echo zen_html_quotes($order->customer['city']); ?>"></td>
                </tr>
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_STATE; ?></td>
                  <td class="main"><input name="update_customer_state" size="25" value="<?php echo zen_html_quotes($order->customer['state']); ?>"></td>
                </tr>
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_POSTCODE; ?></td>
                  <td class="main"><input name="update_customer_postcode" size="25" value="<?php echo $order->customer['postcode']; ?>"></td>
                </tr>
<?php 
/*                
                <tr>
                  <td class="main" align="right"><?php echo ENTRY_COUNTRY; ?></td>
                  <td class="main"><input name="update_customer_country" size="25" value="<?php echo zen_html_quotes($order->customer['country']); ?>"></td>
                </tr>
*/
?>
                <tr>
                  <td class="main" align="right">Customer ID:</td>
                  <td class="main"><input name="update_customer_id" size="10" value="<?php echo zen_html_quotes($order->customer['id']); ?>"></td>
                </tr>
              </table></td>
            </tr>
          </table></td>
       <?php if ($same_billing < 1) { ?>
          <td><table border="0" width="100%" cellspacing="0" cellpadding="2">
            <tr>
              <td class="main"><b><?php echo ENTRY_BILLING_ADDRESS; ?></b></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_name" size="25" value="<?php echo zen_html_quotes($order->billing['name']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_company" size="25" value="<?php echo zen_html_quotes($order->billing['company']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_street_address" size="25" value="<?php echo zen_html_quotes($order->billing['street_address']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_suburb" size="25" value="<?php echo zen_html_quotes($order->billing['suburb']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_city" size="25" value="<?php echo zen_html_quotes($order->billing['city']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_state" size="25" value="<?php echo zen_html_quotes($order->billing['state']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_postcode" size="25" value="<?php echo $order->billing['postcode']; ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_billing_country" size="25" value="<?php echo zen_html_quotes($order->billing['country']); ?>"></td>
            </tr>
          </table></td>
       <?php } ?>
          <td><table border="0" width="100%" cellspacing="0" cellpadding="2">
            <tr>
              <td class="main"><b><?php echo ENTRY_SHIPPING_ADDRESS; ?></b></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_name" size="25" value="<?php echo zen_html_quotes($order->delivery['name']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_company" size="25" value="<?php echo zen_html_quotes($order->delivery['company']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_street_address" size="25" value="<?php echo zen_html_quotes($order->delivery['street_address']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_suburb" size="25" value="<?php echo zen_html_quotes($order->delivery['suburb']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_city" size="25" value="<?php echo zen_html_quotes($order->delivery['city']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_state" size="25" value="<?php echo zen_html_quotes($order->delivery['state']); ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_postcode" size="25" value="<?php echo $order->delivery['postcode']; ?>"></td>
            </tr>
            <tr>
              <td class="main"><input name="update_delivery_country" size="25" value="<?php echo zen_html_quotes($order->delivery['country']); ?>"></td>
            </tr>
          </table></td>
        </tr>
      </table></td>
    </tr>
<!-- End Addresses Block -->
    <tr>
      <td><?php echo zen_draw_separator('pixel_trans.gif', 1, 10); ?></td>
    </tr>
<!-- Begin Phone/Email Block -->
      <tr>
        <td><table border="0" cellspacing="0" cellpadding="2">
      		<tr>
      		  <td class="main"><b><?php echo ENTRY_TELEPHONE_NUMBER; ?></b></td>
      		  <td class="main"><input name='update_customer_telephone' size='15' value='<?php echo $order->customer['telephone']; ?>'></td>
      		</tr>
      		<tr>
      		  <td class="main"><b><?php echo ENTRY_EMAIL_ADDRESS; ?></b></td>
      		  <td class="main"><input name='update_customer_email_address' size='35' value='<?php echo $order->customer['email_address']; ?>'></td>
      		</tr>
<!-- End Phone/Email Block -->
                <tr>
                  <td><?php echo zen_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
                </tr>
      		<tr>
                  <td class="main"><b><?php echo ENTRY_PAYMENT_METHOD; ?></b></td>
                </tr>
                <tr>
                  <td class="main" colspan="4"><?php
                    // Get currently used payment methods
                    $payment_methods = $db->Execute("SELECT DISTINCT payment_method FROM " . TABLE_ORDERS . " ORDER BY payment_method ASC");

                    while(!$payment_methods->EOF) {
                      if ($order->info['payment_method'] == $payment_methods->fields['payment_method']) {
                        $radio_checked = true;
                      }
                      else {
                        $radio_checked = false;
                      }

                      echo zen_draw_radio_field('update_payment_method', $payment_methods->fields['payment_method'], $radio_checked);
                      echo $payment_methods->fields['payment_method'] . '&nbsp;&nbsp;&nbsp;&nbsp;';

                      $payment_methods->MoveNext();
                    }
                  ?></td>
                </tr>
                <tr>
                  <td class="main" colspan="3"><font color="red"><b><?php echo ENTRY_PAYMENT_METHOD_WARNING; ?></b></font></td>
                </tr>
                <tr>
                  <td><?php echo zen_draw_separator('pixel_trans.gif', '1', '3'); ?></td>
                </tr>
        </table></td>
      </tr>
    </td>
  </tr>
<!-- Begin Payment Block -->
      <tr>
	<td><table border="0" cellspacing="0" cellpadding="2">
          <tr>
            <td colspan="2" class="main"><b><u><?php echo ENTRY_PAYMENT_DETAILS; ?></u></b></td>
          </tr>
<?php
        $update_credit_card = 0;
        $update_purchase_order = 0;
        $update_check = 0;
        $update_balance_check = 0;

	if ($order->info['cc_type'] || $order->info['cc_owner'] || $order->info['payment_method'] == "Credit Card" || $order->info['cc_number']) {
	$update_credit_card = 1;
?>
<!-- Begin Credit Card Info Block -->
          <tr>
            <td valign="top"><table border="0" cellspacing="0" cellpadding="2">
            <tr>
              <td class="main"><b><?php echo ENTRY_CREDIT_CARD_TYPE; ?></b></td>
              <td class="main"><input name='update_info_cc_type' size='10' value='<?php echo $order->info['cc_type']; ?>'></td>
	    </tr>
	    <tr>
	      <td class="main"><b><?php echo ENTRY_CREDIT_CARD_OWNER; ?></b></td>
	      <td class="main"><input name='update_info_cc_owner' size='20' value='<?php echo $order->info['cc_owner']; ?>'></td>
	    </tr>
	    <tr>
	      <td class="main"><b><?php echo ENTRY_CREDIT_CARD_NUMBER; ?></b></td>
	      <td class="main"><input name='update_info_cc_number' size='20' value='<?php echo $order->info['cc_number']; ?>'></td>
	    </tr>
	    <tr>
	      <td class="main"><b><?php echo ENTRY_CREDIT_CARD_CVV; ?></b></td>
	      <td class="main"><input name='update_info_cc_cvv' size='3' value='<?php echo $order->info['cc_cvv']; ?>'></td>
	    </tr>
	    <tr>
	      <td class="main"><b><?php echo ENTRY_CREDIT_CARD_EXPIRES; ?></b></td>
	      <td class="main"><input name='update_info_cc_expires' size='4' value='<?php echo $order->info['cc_expires']; ?>'></td>
	    </tr>
	    </table></td>
          </tr>
<!-- End Credit Card Info Block -->
<?php    }

        else if ($order->info['payment_module_code'] == 'purchaseorder') {
          $update_purchase_order = 1;
          $purchase_order_data = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_PURCHASE_ORDER . " WHERE orders_id = '" . (int)$oID . "'");
          $check_data = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK . " WHERE orders_id = '" . (int)$oID . "'");
?>
<!-- Begin Purchase Order Block -->
          <tr>
            <td valign="top"><table border="0" cellspacing="0" cellpadding="2">
              <tr>
                <td class="main"><b><?php echo PURCHASE_ORDER_NUMBER; ?></b></td>
                <td class="main"><?php echo zen_draw_input_field('po_number', $purchase_order_data->fields['po_number'], 'size="25"'); ?></td>
              </tr>
            </table></td>
<?php
          if (zen_not_null($check_data->fields['check_number']) || zen_not_null($check_data->fields['check_name']) || zen_not_null($check_data->fields['check_amount'])) {
            $update_check = 1;
?>
            <td width="35">&nbsp;</td>
            <td valign="top"><table border="0" cellspacing="0" cellpadding="2">
              <tr>
                <td class="main" width="110"><b><?php echo CHECK_NUMBER; ?></b></td>
                <td class="main"><?php echo zen_draw_input_field('check_number', $check_data->fields['check_number'], 'size="25"'); ?></td>
              </tr>
              <tr>
                <td class="main" width="110"><b><?php echo CHECK_NAME; ?></b></td>
                <td class="main"><?php echo zen_draw_input_field('check_name', $check_data->fields['check_name'], 'size="25"');?></td>
              </tr>
              <tr>
                <td class="main" width="110"><b><?php echo CHECK_AMOUNT; ?></b></td>
                <td class="main"><?php echo zen_draw_input_field('check_amount', $check_data->fields['check_amount'], 'size="8"'); ?></td>
              </tr>
            </table></td>
<?php

            if ($check_data->fields['balance_status'] == 2) {
            $update_balance_check = 1;
            $balance_check_data = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK_BALANCE . "
                                                WHERE check_index = '" . $check_data->fields['check_index'] . "'");
            echo zen_draw_hidden_field('check_index', $check_data->fields['check_index']);
?>
            <td width="35">&nbsp;</td>
            <td valign="top"><table border="0" cellspacing="0" cellpadding="2">
              <tr>
                <td colspan="2" class="main"><b><?php
                  if ($balance_check_data->fields['check_direction'] > 0) {
                    echo '<font color="blue">Balance Check';
                  }
                  else {
                    echo '<font color="red">Rebate Check';
                  }
                  echo '</font></b>';
                  echo '&nbsp;&nbsp;(Value: ' . $currencies->format($balance_check_data->fields['check_amount']) . ')';
                ?></td>
              </tr>
              <tr>
                <td class="main" width="110"><?php
                  echo '<b>' . CHECK_NUMBER . '</b>';
                ?></td>
                <td class="main"><?php echo zen_draw_input_field('balance_check_number', $balance_check_data->fields['check_number'], 'size="25"'); ?></td>
              </tr>
              <tr>
                <td class="main" width="110"><b><?php echo CHECK_NAME; ?></b></td>
                <td class="main"><?php echo zen_draw_input_field('balance_check_name', $balance_check_data->fields['check_name'], 'size="25"'); ?></td>
              </tr>
            </table></td>
<!-- End Purchase Order Block -->
<?php
            }  // END if ($check_data->fields['balance_status'] == 2)

          } // END if (zen_not_null($check_data->fields['check_number']) || ...

        } // END else if ($order->info['payment_module_code'] == 'purchaseorder')

        else if ($order->info['payment_module_code'] == 'moneyorder') {
          $update_check = 1;
          $check_data = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK . " WHERE orders_id = '" . (int)$oID . "'");
?>
<!-- Begin Check Block -->
        <tr>
          <td valign="top"><table border="0" cellspacing="0" cellpadding="2">
            <tr>
              <td class="main" width="110"><b><?php echo CHECK_NUMBER; ?></b></td>
              <td class="main"><?php echo zen_draw_input_field('check_number', $check_data->fields['check_number'], 'size="25"'); ?></td>
            </tr>
            <tr>
              <td class="main" width="110"><b><?php echo CHECK_NAME; ?></b></td>
              <td class="main"><?php echo zen_draw_input_field('check_name', $check_data->fields['check_name'], 'size="25"'); ?></td>
            </tr>
            <tr>
              <td class="main" width="110"><b><?php echo CHECK_AMOUNT; ?></b></td>
              <td class="main"><?php echo zen_draw_input_field('check_amount', $check_data->fields['check_amount'], 'size="8"'); ?></td>
            </tr>
          </table></td>
<?php
          if ($check_data->fields['balance_status'] == 2) {
            $update_balance_check = 1;
            $balance_check_data = $db->Execute("SELECT * FROM " . TABLE_PAYMENT_CHECK_BALANCE . "
                                                WHERE check_index = '" . $check_data->fields['check_index'] . "'");
            echo zen_draw_hidden_field('check_index', $check_data->fields['check_index']);
?>
            <td valign="top"><table border="0" cellspacing="0" cellpadding="2">
              <tr>
                <td class="main"><b><?php
                  if ($balance_check_data->fields['check_direction'] > 0) {
                    echo '<font color="blue">Balance Check';
                  }
                  else {
                    echo '<font color="red">Rebate Check';
                  }
                ?></font></b></td>
                <td class="main"><?php echo '(Value: ' . $currencies->format($balance_check_data->fields['check_amount']) . ')'; ?></td>
              </tr>
              <tr>
                <td class="main" width="110"><?php
                  echo '<b>' . CHECK_NUMBER . '</b>';
                ?></td>
                <td class="main"><?php echo zen_draw_input_field('balance_check_number', $balance_check_data->fields['check_number'], 'size="25"'); ?></td>
              </tr>
              <tr>
                <td class="main" width="110"><b><?php echo CHECK_NAME; ?></b></td>
                <td class="main"><?php echo zen_draw_input_field('balance_check_name', $balance_check_data->fields['check_name'], 'size="25"'); ?></td>
              </tr>
            </table></td>
<!-- End Check Block -->
<?php
            }
          }

          else {
?>
            <tr>
              <td class="main"><b><?php echo TEXT_NO_VALID_PAYMENT; ?></b></td>
            </tr>
<?php
          }

        echo zen_draw_hidden_field('update_credit_card', $update_credit_card) . "\n";
        echo zen_draw_hidden_field('update_purchase_order', $update_purchase_order) . "\n";
        echo zen_draw_hidden_field('update_check', $update_check) . "\n";
        echo zen_draw_hidden_field('update_balance_check', $update_balance_check) . "\n";
?>
       </table></td>
     </tr>
<!-- End Payment Block -->

      <tr>
	<td><?php echo zen_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>

<!-- Begin Products Listing Block -->
      <tr>
	<td><table border="0" width="100%" cellspacing="0" cellpadding="2">
	  <tr class="dataTableHeadingRow">
	    <td class="dataTableHeadingContent" align="center"><?php echo 'Split'; ?></td>
	    <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_PRODUCTS; ?></td>
	    <td class="dataTableHeadingContent"><?php echo TABLE_HEADING_PRODUCTS_MODEL; ?></td>
	    <td class="dataTableHeadingContent" align="center"><?php echo TABLE_HEADING_TAX; ?></td>
	    <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_UNIT_PRICE; ?></td>
	    <td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_TOTAL_PRICE; ?></td>
	  </tr>
<?
      	// Override order.php Class's Field Limitations
		$index = 0;
		$order->products = array();
		$orders_products_query = $db -> Execute("SELECT * FROM " . TABLE_ORDERS_PRODUCTS . " WHERE orders_id = '" . (int)$oID . "'");
		while (!$orders_products_query->EOF) {
                  $order->products[$index] = array(
		                             'qty' => $orders_products_query->fields['products_quantity'],
                                             'name' => str_replace("'", "&#39;", $orders_products_query->fields['products_name']),
                                             'model' => $orders_products_query->fields['products_model'],
                                             'tax' => $orders_products_query->fields['products_tax'],
                                             'price' => $orders_products_query->fields['products_price'],
                                             'final_price' => $orders_products_query->fields['final_price'],
                                             'orders_products_id' => $orders_products_query->fields['orders_products_id']);
		$subindex = 0;
		$attributes_query_string = "SELECT * FROM " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " WHERE orders_id = '" . (int)$oID . "' AND orders_products_id = '" . (int)$orders_products['orders_products_id'] . "'";
		$attributes_query = $db -> Execute($attributes_query_string);

                 while (!$attributes_query->EOF) {
		  $order->products[$index]['attributes'][$subindex] = array(
		                                                      'option' => $attributes_query->fields['products_options'],
		                                                      'value' => $attributes_query->fields['products_options_values'],
		                                                      'prefix' => $attributes_query->fields['price_prefix'],
		                                                      'price' => $attributes_query->fields['options_values_price'],
		                                                      'orders_products_attributes_id' => $attributes_query->fields['orders_products_attributes_id']);
		$subindex++;
      $attributes_query -> MoveNext();
		}
		$index++;
      $orders_products_query -> MoveNext();

		}
		
	for ($i = 0; $i < sizeof($order->products); $i++) {
		$orders_products_id = $order->products[$i]['orders_products_id'];

	      echo '      <tr class="dataTableRow">' . "\n" .
	           '        <td class="dataTableContent" valign="top" align="center">' . zen_draw_checkbox_field('split_products[' . $i . ']', $orders_products_id) . "\n" .
		   '        <td class="dataTableContent" valign="top">' . "<input name='update_products[$orders_products_id][qty]' size='2' value='" . $order->products[$i]['qty'] . "'>&nbsp;x" .
		   "        <input name='update_products[$orders_products_id][name]' size='64' value='" . $order->products[$i]['name'] . "'>";

		// Has Attributes?
		if (sizeof($order->products[$i]['attributes']) > 0) {
			for ($j=0; $j<sizeof($order->products[$i]['attributes']); $j++) {
				$orders_products_attributes_id = $order->products[$i]['attributes'][$j]['orders_products_attributes_id'];
				echo '<br><nobr><small>&nbsp;<i> - ' . 
					 "<input name='update_products[$orders_products_id][attributes][$orders_products_attributes_id][option]' size='32' value='" . $order->products[$i]['attributes'][$j]['option'] . "'>" . 
					 ': ' . 
					 "<input name='update_products[$orders_products_id][attributes][$orders_products_attributes_id][value]' size='25' value='" . $order->products[$i]['attributes'][$j]['value'];
				if ($order->products[$i]['attributes'][$j]['price'] != '0') echo ' (' . $order->products[$i]['attributes'][$j]['prefix'] . $currencies->format($order->products[$i]['attributes'][$j]['price'] * $order->products[$i]['qty'], true, $order->info['currency'], $order->info['currency_value']) . ')';
				echo "'>";
				echo '</i></small></nobr>';
			}
		}
		
		echo '	    </td>' . "\n" .
		     '	    <td class="dataTableContent" valign="top">' . "<input name='update_products[$orders_products_id][model]' size='12' value='" . $order->products[$i]['model'] . "'>" . '</td>' . "\n" .
		     '	    <td class="dataTableContent" align="center" valign="top">' . "<input name='update_products[$orders_products_id][tax]' size='3' value='" . zen_display_tax_value($order->products[$i]['tax']) . "'>" . '%</td>' . "\n" .
		     '	    <td class="dataTableContent" align="right" valign="top">' . "<input name='update_products[$orders_products_id][final_price]' size='5' value='" . number_format($order->products[$i]['final_price'], 2, '.', '') . "'>" . '</td>' . "\n" .
		     '	    <td class="dataTableContent" align="right" valign="top">' . $currencies->format($order->products[$i]['final_price'] * $order->products[$i]['qty'], true, $order->info['currency'], $order->info['currency_value']) . '</td>' . "\n" .
		     '	  </tr>' . "\n";
	}
	?>
<!-- End Products Listings Block -->

<!-- Begin Order Total Block -->
	  <tr>
	    <td align="right" colspan="7">
	      <table border="0" cellspacing="0" cellpadding="2" width="100%">
	    	<tr>
	    	  <td valign="top" colspan="2"><table border="0" cellspacing="0" cellpadding="0">
                    <tr>
                      <td valign="top">&nbsp;&nbsp;&nbsp;&nbsp;<?php echo zen_image(DIR_WS_IMAGES . OTHER_IMAGE_ARROW_SOUTH_EAST); ?></td>
                      <td valign="top"><?php echo zen_draw_checkbox_field('notify_split', 1); ?></td>
                      <td valign="middle" class="smallText"><?php
                        echo '<b>' . ENTRY_NOTIFY_CUSTOMER . '</b>' . '<br>';
                        echo TEXT_SPLIT_EXPLAIN . '<B>' . $nextID . '</B>';
                      ?></td>
                    </tr>
                  </table></td>
	    	  <td align='center' valign='top'>&nbsp;

	    	    <br><a href="<? print $PHP_SELF . "?oID=$oID&action=add_product&step=1"; ?>"><u><b><font color="blue" size='3'><?php echo TEXT_DATE_ORDER_ADD_NEW; ?> </font></b></u></a>

	    	  </td>
	    	<td align='right'>
	    	<table border="0" cellspacing="0" cellpadding="2">
<?php

      	// Override order.php Class's Field Limitations
	$totals_query = $db -> Execute("SELECT * FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '" . (int)$oID . "' ORDER BY sort_order");
	$order->totals = array();

        while (!$totals_query->EOF) {
         $order->totals[] = array('title' => $totals_query->fields['title'],
                                  'text' => $totals_query->fields['text'],
                                  'class' => $totals_query->fields['class'],
                                  'value' => $totals_query->fields['value'],
                                  'sort_order' => $totals_query->fields['sort_order'],
                                  'orders_total_id' => $totals_query->fields['orders_total_id']);
         $totals_query -> MoveNext();
        }
      
	$TotalsArray = array();
	for ($i = 0; $i < sizeof($order->totals); $i++) {
		$TotalsArray[] = array("Name" => $order->totals[$i]['title'],
		                       "Price" => number_format($order->totals[$i]['value'], 2, '.', ''),
		                       "Class" => $order->totals[$i]['class'],
		                       "Sort" => $order->totals[$i]['sort_order'],
		                       "TotalID" => $order->totals[$i]['orders_total_id']);

                $TotalsArray[] = array("Name" => "          ",
                                       "Price" => "",
                                       "Class" => "ot_custom",
                                       "Sort" => "0",
                                       "TotalID" => "0");
	}
        // These blank entries will appear twice on every edit to
        // allow entering a special order adjustment
	array_pop($TotalsArray);
	$radio_count = 0;
	foreach($TotalsArray as $TotalIndex => $TotalDetails) {
		$TotalStyle = "smallText";

		if(($TotalDetails["Class"] == "ot_subtotal") || ($TotalDetails["Class"] == "ot_total")) {
			echo	'	      <tr>' . "\n" .
				'		<td class="main" colspan="2" align="right"><b>' . $TotalDetails["Name"] . '</b></td>' .
				'		<td class="main"><b>' . $TotalDetails["Price"] .
						"<input name='update_totals[$TotalIndex][sort_order]' type='hidden' value='" . $TotalDetails["Sort"] . "'>" .
						"<input name='update_totals[$TotalIndex][title]' type='hidden' value='" . trim($TotalDetails["Name"]) . "' size='" . strlen($TotalDetails["Name"]) . "' >" .
						"<input name='update_totals[$TotalIndex][value]' type='hidden' value='" . $TotalDetails["Price"] . "' size='6' >" .
						"<input name='update_totals[$TotalIndex][class]' type='hidden' value='" . $TotalDetails["Class"] . "'>\n" . 
						"<input name='update_totals[$TotalIndex][total_id]' type='hidden' value='" . $TotalDetails["TotalID"] . "'>" . '</b></td>' .
				'	      </tr>' . "\n";
		}
		elseif($TotalDetails["Class"] == "ot_tax") {
			echo	'	      <tr>' . "\n" .
				'		<td align="right" class="' . $TotalStyle . '">' .
                        "<input name='update_totals[$TotalIndex][sort_order]' type='hidden' value='" . $TotalDetails["Sort"] . "'>" .
                        "<input name='update_totals[$TotalIndex][title]' size='" . strlen(trim($TotalDetails["Name"])) . "' value='" . trim($TotalDetails["Name"]) . "'>" . '</td>' . "\n" .
				'		<td class="main"><b>' . $TotalDetails["Price"] .
						"<input name='update_totals[$TotalIndex][value]' type='hidden' value='" . $TotalDetails["Price"] . "' size='6' >" .
						"<input name='update_totals[$TotalIndex][class]' type='hidden' value='" . $TotalDetails["Class"] . "'>\n" .
						"<input name='update_totals[$TotalIndex][total_id]' type='hidden' value='" . $TotalDetails["TotalID"] . "'>" . '</b></td>' .
				'	      </tr>' . "\n";
		}
		else {
			echo '             <tr>' . "\n" .
			     '               <td align="right" colspan="2" class="' . $TotalStyle . '">' .
						"<input type='hidden' name='update_totals[$TotalIndex][sort_order]' value='" . $TotalDetails["Sort"] . "'>" .
                        "<input name='update_totals[$TotalIndex][title]' size='" . strlen(trim($TotalDetails["Name"])) . "' value='" . trim($TotalDetails["Name"]) . "'>" . '</td>' . "\n" .
			     '               <td align="right" class="' . $TotalStyle . '">' . "<input name='update_totals[$TotalIndex][value]' size='6' value='" . $TotalDetails["Price"] . "'>" .
						"<input type='hidden' name='update_totals[$TotalIndex][class]' value='" . $TotalDetails["Class"] . "'>" .
						"<input type='hidden' name='update_totals[$TotalIndex][total_id]' value='" . $TotalDetails["TotalID"] . "'>" .
						'</td>' . "\n" .
			     '             </tr>' . "\n";
		}
	}
?>
	    	</table></td>
	      </tr>
            </table></td>
	  </tr>
	<!-- End Order Total Block -->
	</table></td>
      </tr>
      	
      <tr>
        <td><?php echo zen_draw_separator('pixel_trans.gif', '1', '10'); ?></td>
      </tr>
      <!-- Begin Order Status History -->
      <tr>
        <td class="main"><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
        <td class="main"><table border="1" cellspacing="0" cellpadding="5">
          <tr>
            <td class="smallText" align="center"><b><?php echo TABLE_HEADING_DATE_ADDED; ?></b></td>
            <td class="smallText" align="center"><b><?php echo TABLE_HEADING_CUSTOMER_NOTIFIED; ?></b></td>
            <td class="smallText" align="center"><b><?php echo TABLE_HEADING_STATUS; ?></b></td>
            <td class="smallText" align="center"><b><?php echo TABLE_HEADING_COMMENTS; ?></b></td>
            <td class="smallText" align="center"><b><?php echo TABLE_HEADING_DELETE_COMMENTS; ?></b></td>
          </tr>
<?php
    $orders_history = $db->Execute("SELECT * FROM " . TABLE_ORDERS_STATUS_HISTORY . " WHERE orders_id = '" . zen_db_input($oID) . "' ORDER BY orders_status_history_id ASC");
    if ($orders_history->RecordCount()) {
      while (!$orders_history->EOF){
        echo '          <tr>' . "\n" .
             '            <td class="smallText" align="center">' . zen_datetime_short($orders_history->fields['date_added']) . '</td>' . "\n" .
             '            <td class="smallText" align="center">';
        if ($orders_history->fields['customer_notified'] == '1') {
          echo zen_image(DIR_WS_ICONS . 'tick.gif', ICON_TICK) . "</td>\n";
        }
        else {
          echo zen_image(DIR_WS_ICONS . 'cross.gif', ICON_CROSS) . "</td>\n";
        }

        $status_id = 'status_' . $orders_history->fields['orders_status_history_id'];
        $status_default = $orders_history->fields['orders_status_id'];
        $comments_id  = 'comments_' . $orders_history->fields['orders_status_history_id'];
        $comments_default = $orders_history->fields['comments'];
        $delete_id = 'delete_' . $orders_history->fields['orders_status_history_id'];

        echo '            <td>' . zen_draw_pull_down_menu($status_id, $orders_statuses, $status_default) . '</td>' . "\n";
        echo '            <td>' . zen_draw_textarea_field($comments_id, 'soft', '50', '5', $comments_default) . '</td>' . "\n";
        echo '            <td align="center">' . zen_draw_checkbox_field($delete_id) . '</td>' . "\n";
        echo '          </tr>' . "\n";
        $orders_history -> MoveNext();
      }
    }
    else {
      echo '          <tr>' . "\n" .
           '            <td class="smallText" colspan="5">' . TEXT_NO_ORDER_HISTORY . '</td>' . "\n" .
           '          </tr>' . "\n";
    }
?>
          </table></td>
          <!-- End Order Status History -->
          <td align="right" valign="center"><INPUT TYPE="SUBMIT" VALUE="<?php echo BUTTON_UPDATE_ORDER; ?>"></td>
        </tr></table></td>
      </tr>
      <tr>
        <td><?php echo zen_draw_separator('pixel_trans.gif', '1', '3'); ?></td>
      </tr>
      <tr>
        <td><?php echo zen_draw_separator(); ?></td>
      </tr>
      <tr>
        <td><?php echo zen_draw_separator('pixel_trans.gif', '1', '3'); ?></td>
      </tr>
      <tr>
        <td><table width="100%" border="0" cellspacing="0" cellpadding="2">
          <tr>
            <td class="pageHeading" align="left" valign="top"><?php echo HEADING_TITLE . ' #' . $oID; ?></td>
            <td class="main" align="center" valign="middle"><?php echo $prev_button; ?></td>
            <td class="smallText" align="center" valign="center"><?php
              echo SELECT_ORDER_LIST . '<br>';
              echo zen_draw_form('search_oid', FILENAME_SUPER_EDIT, '', 'get', '', true);
              echo zen_draw_pull_down_menu('oID', $orders_id_list, '', 'onChange="this.form.submit();"');
              echo zen_draw_hidden_field('action', 'edit');
              echo '</form>';
            ?></td>
            <td class="main" align="center" valign="middle"><?php echo $next_button; ?></td>
            <td align="right" valign="bottom"><?php
              echo '<a href="' . zen_href_link(FILENAME_SUPER_ORDERS, 'oID=' . $oID . '&action=edit', 'NONSSL') . '">' . zen_image_button('button_details.gif', IMAGE_EDIT) . '</a>&nbsp;&nbsp;';
              echo '<a href="' . zen_href_link(FILENAME_SUPER_INVOICE, 'oID=' . $_GET['oID']) . '" TARGET="_blank">' . zen_image_button('button_invoice.gif', IMAGE_ORDERS_INVOICE) . '</a>&nbsp;&nbsp;';
              echo '<a href="' . zen_href_link(FILENAME_SUPER_PACKINGSLIP, 'oID=' . $_GET['oID']) . '" TARGET="_blank">' . zen_image_button('button_packingslip.gif', IMAGE_ORDERS_PACKINGSLIP) . '</a>&nbsp;&nbsp;';
              echo '<a href="' . zen_href_link(FILENAME_SUPER_ORDERS, zen_get_all_get_params(array('action','referer'))) . '">' . zen_image_button('button_back.gif', IMAGE_BACK) . '</a>';
            ?></td>
          </tr>
        </table></td>
      </tr>
</form>
<?php
  }

if($action == "add_product")
{
?>
      <tr>
        <td width="100%"><table border="0" width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td class="pageHeading"><?php echo ADDING_TITLE; ?> #<?php echo $oID; ?></td>
            <td class="pageHeading" align="right"><?php echo zen_draw_separator('pixel_trans.gif', 1, HEADING_IMAGE_HEIGHT); ?></td>
            <td class="pageHeading" align="right"><?php echo '<a href="' . zen_href_link(FILENAME_SUPER_EDIT, 'oID=' . $oID) . '">' . zen_image_button('button_back.gif', IMAGE_BACK) . '</a>'; ?></td>
          </tr>
        </table></td>
      </tr>

<?
	// ############################################################################
	//   Get List of All Products
	// ############################################################################
        $ProductList = zen_get_products();

		// ksort($ProductList);
		
		$LastOptionTag = "";
		$ProductSelectOptions = "<option value='0'>Don't Add New Product" . $LastOptionTag . "\n";
		$ProductSelectOptions .= "<option value='0'>&nbsp;" . $LastOptionTag . "\n";
		foreach($ProductList as $Category => $Products)
		{
			$ProductSelectOptions .= "<option value='0'>$Category" . $LastOptionTag . "\n";
			$ProductSelectOptions .= "<option value='0'>---------------------------" . $LastOptionTag . "\n";
			asort($Products);
			foreach($Products as $Product_ID => $Product_Name)
			{
				$ProductSelectOptions .= "<option value='$Product_ID'> &nbsp; $Product_Name" . $LastOptionTag . "\n";
			}
			
			if($Category != $LastCategory)
			{
				$ProductSelectOptions .= "<option value='0'>&nbsp;" . $LastOptionTag . "\n";
				$ProductSelectOptions .= "<option value='0'>&nbsp;" . $LastOptionTag . "\n";
			}
		}
	
	
	// ############################################################################
	//   Add Products Steps
	// ############################################################################
	
		print "<tr><td><table border='0'>\n";
		
		// Set Defaults
			if(!IsSet($add_product_categories_id))
			$add_product_categories_id = 0;

			if(!IsSet($add_product_products_id))
			$add_product_products_id = 0;
		
		// Step 1: Choose Category
			print "<tr class=\"dataTableRow\"><form action='$PHP_SELF?oID=$oID&action=$action' method='POST'>\n";
			print "<td class='dataTableContent' align='right'><b>STEP 1:</b></td><td class='dataTableContent' valign='top'>";
			echo ' ' . zen_draw_pull_down_menu('add_product_categories_id', zen_get_category_tree(), $current_category_id, 'onChange="this.form.submit();"');
			print "<input type='hidden' name='step' value='2'>";
			print "</td>\n";
			print "</form></tr>\n";
			print "<tr><td colspan='3'>&nbsp;</td></tr>\n";

		// Step 2: Choose Product
		if(($step > 1) && ($add_product_categories_id > 0))
		{
			print "<tr class=\"dataTableRow\"><form action='$PHP_SELF?oID=$oID&action=$action' method='POST'>\n";
			print "<td class='dataTableContent' align='right'><b>STEP 2:</b></td><td class='dataTableContent' valign='top'><select name=\"add_product_products_id\" onChange=\"this.form.submit();\">";
			$ProductOptions = "<option value='0'>" .  ADDPRODUCT_TEXT_SELECT_PRODUCT . "\n";
			asort($ProductList[$add_product_categories_id]);
			foreach($ProductList[$add_product_categories_id] as $ProductID => $ProductName)
			{
			$ProductOptions .= "<option value='$ProductID'> $ProductName\n";
			}
			$ProductOptions = str_replace("value='$add_product_products_id'","value='$add_product_products_id' selected", $ProductOptions);
			print $ProductOptions;
			print "</select></td>\n";
			print "<input type='hidden' name='add_product_categories_id' value='$add_product_categories_id'>";
			print "<input type='hidden' name='step' value='3'>";
			print "</form></tr>\n";
			print "<tr><td colspan='3'>&nbsp;</td></tr>\n";
		}

		// Step 3: Choose Options
		if(($step > 2) && ($add_product_products_id > 0))
		{
			// Get Options for Products
			$result = $db -> Execute("SELECT * FROM " . TABLE_PRODUCTS_ATTRIBUTES . " pa LEFT JOIN " . TABLE_PRODUCTS_OPTIONS . " po ON po.products_options_id=pa.options_id LEFT JOIN " . TABLE_PRODUCTS_OPTIONS_VALUES . " pov ON pov.products_options_values_id=pa.options_values_id WHERE products_id='$add_product_products_id' and po.language_id = '" . (int)$_SESSION['languages_id'] . "'");
			
			// Skip to Step 4 if no Options
			if($result->RecordCount() == 0) {
				print "<tr class=\"dataTableRow\">\n";
				print "<td class='dataTableContent' align='right'><b>STEP 3:</b></td><td class='dataTableContent' valign='top' colspan='2'><i>No Options - Skipped...</i></td>";
				print "</tr>\n";
				$step = 4;
			}
			else {

                while (!$result->EOF){
                        extract($result->fields,EXTR_PREFIX_ALL,"db");
                        $Options[$db_products_options_id] = $db_products_options_name;
                        $ProductOptionValues[$db_products_options_id][$db_products_options_values_id] = $db_products_options_values_name;
                        $result->MoveNext();
                }
			
				print "<tr class=\"dataTableRow\"><form action='$PHP_SELF?oID=$oID&action=$action' method='POST'>\n";
				print "<td class='dataTableContent' align='right'><b>STEP 3:</b></td><td class='dataTableContent' valign='top'>";
				foreach($ProductOptionValues as $OptionID => $OptionValues)
				{
					$OptionOption = "<b>" . $Options[$OptionID] . "</b> - <select name='add_product_options[$OptionID]'>";
					foreach($OptionValues as $OptionValueID => $OptionValueName)
					{
					$OptionOption .= "<option value='$OptionValueID'> $OptionValueName\n";
					}
					$OptionOption .= "</select><br>\n";
					
					if(IsSet($add_product_options))
					$OptionOption = str_replace("value='" . $add_product_options[$OptionID] . "'","value='" . $add_product_options[$OptionID] . "' selected",$OptionOption);
					
					print $OptionOption;
				}		
				print "</td>";
				print "<td class='dataTableContent' align='center'><input type='submit' value='" . ADDPRODUCT_TEXT_OPTIONS_CONFIRM . "'>";
				print "<input type='hidden' name='add_product_categories_id' value='$add_product_categories_id'>";
				print "<input type='hidden' name='add_product_products_id' value='$add_product_products_id'>";
				print "<input type='hidden' name='step' value='4'>";
				print "</td>\n";
				print "</form></tr>\n";
			}

			print "<tr><td colspan='3'>&nbsp;</td></tr>\n";
		}

		// Step 4: Confirm
		if($step > 3)
		{
			print "<tr class=\"dataTableRow\"><form action='$PHP_SELF?oID=$oID&action=$action' method='POST'>\n";
			print "<td class='dataTableContent' align='right'><b>STEP 4:</b></td>";
			print "<td class='dataTableContent' valign='top'><input name='add_product_quantity' size='2' value='1'>" . ADDPRODUCT_TEXT_CONFIRM_QUANTITY . "</td>";
			print "<td class='dataTableContent' align='center'><input type='submit' value='" . ADDPRODUCT_TEXT_CONFIRM_ADD_NOW . "'>";

			if(IsSet($add_product_options))
			{
				foreach($add_product_options as $option_id => $option_value_id)
				{
					print "<input type='hidden' name='add_product_options[$option_id]' value='$option_value_id'>";
				}
			}
			print "<input type='hidden' name='add_product_categories_id' value='$add_product_categories_id'>";
			print "<input type='hidden' name='add_product_products_id' value='$add_product_products_id'>";
			print "<input type='hidden' name='step' value='5'>";
			print "</td>\n";
			print "</form></tr>\n";
		}

		print "</table></td></tr>\n";
}
?>
    </table></td>
<!-- body_text_eof //-->
  </tr>
</table>
<!-- body_eof //-->

<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
</body>
</html>